#include "testlib.h"
#include <set>

using namespace std;

int MAXN[] = {(int) 1e5,         1, 50, 300, 2000,      2000, 15000,     15000,     15000};
int MAXC[] = {(int) 1e8, (int) 1e8, 50, 300, 2000, (int) 1e8,  2000, (int) 1e5, (int) 1e8};

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    int group = 0;
    if (!validator.group().empty()) {
        group = validator.group()[0] - '0';
    }

    int r = inf.readInt(1, MAXC[group], "r");
    inf.readSpace();
    int c = inf.readInt(1, MAXC[group], "c");
    inf.readEoln();

    int n = inf.readInt(1, MAXN[group], "n");
    inf.readEoln();

    set<pair<int, int>> pts;
    for (int i = 0; i < n; i++) {
        int x = inf.readInt(1, r, format("x[%d]", i));
        inf.readSpace();
        int y = inf.readInt(1, c, format("y[%d]", i));
        inf.readEoln();

        ensuref(!pts.count({x, y}), "duplicate point (%d, %d)", x, y);
        pts.insert({x, y});
    }

    inf.readEof();
}
