#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>

using namespace std;

int dx[] = {0, 0, -1, 1};
int dy[] = {-1, 1, 0, 0};

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int r, c;
    cin >> r >> c;
    int n;
    cin >> n;
    vector<vector<int>> dst(r, vector<int> (c));
    vector<vector<bool>> used(r, vector<bool> (c));
    deque<pair<int, int>> q;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;

        used[x][y] = true;
        q.push_back({x, y});
    }

    while (!q.empty()) {
        auto u = q.front();
        q.pop_front();
        int x = u.first, y = u.second;
        for (int d = 0; d < 4; d++) {
            int xx = x + dx[d], yy = y + dy[d];
            if (0 <= xx && xx < r && 0 <= yy && yy < c && !used[xx][yy]) {
                used[xx][yy] = true;
                dst[xx][yy] = dst[x][y] + 1;
                q.push_back({xx, yy});
            }
        }
    }

    int mx = 0;
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < c; j++) {
            mx = max(mx, dst[i][j]);
        }
    }

    cout << mx << endl;

    return 0;
}