/**
 *    author:  [itmo] enot.1.10
 *    created: 21.03.2018 15:18:37
**/
#include <iostream>
#include <vector>
#include <algorithm>
#include <ctime>
#include <random>

#define F first
#define S second
#define pb push_back
#define forn(i, n) for(int i = 0 ; (i) < (n) ; ++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__),fflush(stderr)
#define sz(a) ((int)(a).size())
#define all(a) (a).begin(),a.end()
#define pw(x) (1LL<<(x))

using namespace std;

typedef long long ll;
typedef double dbl;
typedef vector<int> vi;
typedef pair<int, int> pi;

const int inf = 1.01e9;
const dbl eps = 1e-9;


const int N = 15010;

struct pt
{
    int x, y;

    pt(){}
    pt(int xx, int yy): x(xx), y(yy) {}
};

inline int dist(pt A, pt B)
{
    return abs(A.x - B.x) + abs(A.y - B.y);
}

int R, C;

inline int in(int x, int y)
{
    return 0 <= x && x < R && 0 <= y && y < C;
}

dbl TIME()
{
    return (dbl)clock() * 1. / CLOCKS_PER_SEC;
}

mt19937 rnd;



pt a[N];
int n;

int score(pt A)
{
    int res = inf;
    forn(i, n) res = min(res, dist(A, a[i]));
    return res;
}



int p[8];

int main()
{
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    scanf("%d%d", &R, &C);
    scanf("%d", &n);
    forn(i, n)
    {
        int x, y;
        scanf("%d%d", &x, &y);
        --x, --y;
        a[i] = {x, y};
    }

    vector<dbl> rates = {0.5, 1. / 3, 2. / 3, 0.25};
    vector<vector<pi>> moves = {
            {{1, 0}, {0, 1}, {-1, 0}, {0, -1}},
            {{2, 0}, {1, 1}, {0, 2}, {-1, 1}, {-2, 0}, {-1, -1}, {0, -2}, {1, -1}},
            {{2, 1}, {1, 2}, {-1, 2}, {-2, 1}, {-2, -1}, {-1, -2}, {1, -2}, {2, -1}}
    };

    int res = 0;

    while (TIME() < 1.9)
    {
        pt A(rnd() % R, rnd() % C);
        int val = score(A);
        int d = max(R, C);

        dbl r = rates[rnd() % sz(rates)];
        vector<pi> m = moves[rnd() % sz(moves)];

        while (d > 0)
        {
            shuffle(all(m), rnd);
            forn(i, sz(m))
            {
                pt B = {A.x + m[i].F * d, A.y + m[i].S * d};
                if (!in(B.x, B.y)) continue;
                int val2 = score(B);
                if (val2 > val)
                {
                    A = B;
                    val = val2;
                    res = max(res, val);
                }
            }
            d = (int)(d * r);
        }
    }
    printf("%d\n", res);



#ifdef home
    eprintf("time = %d ms\n", (int)(clock() * 1000. / CLOCKS_PER_SEC));
#endif
    return 0;
}