#include "testlib.h"

using namespace std;

const int MAXX = (int) 1e9;

int MAXB[] = {(int) 1e9,         0,         0,         0,         0, (int) 1e9, (int) 1e9};
int MAXS[] = {       10,         0,        10,         0,        10,         0,        10};
int MAXQ[] = {(int) 1e5,        50,        50,      1000,      1000, (int) 1e5, (int) 1e5};
int MAXN[] = {     1000,        50,        50,      1000,      1000,      1000,      1000};
int MAXA[] = {(int) 1e9, (int) 1e5, (int) 1e5, (int) 1e9, (int) 1e9, (int) 1e9, (int) 1e9};

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    int gr = 0;
    if (!validator.group().empty()) {
        gr = validator.group()[0] - '0';
    }

    int n = inf.readInt(1, MAXN[gr], "n");
    inf.readSpace();
    int m = inf.readInt(1, MAXN[gr], "m");
    inf.readSpace();
    int k = inf.readInt(1, n, "k");
    inf.readSpace();
    int s = inf.readInt(0, min(MAXS[gr], m), "s");
    inf.readEoln();

    vector<int> a(k);
    for (int i = 0; i < k; i++) {
        a[i] = inf.readInt(1, MAXA[gr], format("a[%d]", i));
        if (i != k - 1) {
            inf.readSpace();
        }
    }
    inf.readEoln();

    for (int i = 0; i + 1 < k; i++) {
        ensuref(a[i] > a[i + 1], "a[%d] = %d, more than a[%d] = %d", i, a[i], i + 1, a[i + 1]);
    }
    ensuref(a[k - 1] > 0, "a[k - 1] less or equal to zero");

    vector<int> b(n);
    for (int i = 0; i < n; i++) {
        b[i] = inf.readInt(0, MAXB[gr], format("b[%d]", i));
        if (i != n - 1) {
            inf.readSpace();
        }
    }
    inf.readEoln();

    for (int i = 0; i < m; i++) {
        vector<bool> have(n);
        for (int j = 0; j < n; j++) {
            int p = inf.readInt(1, n, format("p[%d][%d]", i, j));
            p--;
            ensuref(!have[p], "duplicate team %d in list %d", p, i);
            have[p] = true;
            if (j < n - 1) {
                inf.readSpace();
            }
        }
        inf.readEoln();
    }

    int q = inf.readInt(1, MAXQ[gr], "q");
    inf.readEoln();
    for (int i = 0; i < q; i++) {
        int u = inf.readInt(1, n, format("u[%d]", i));
        inf.readSpace();
        int v = inf.readInt(1, n, format("v[%d]", i));
        inf.readEoln();

        ensuref(u != v, "u[%d] = v[%d] = %d", i, i, u);
    }

    inf.readEof();
}
