#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <string>
#include <cassert>
#include <bitset>
#include <initializer_list>
#include <unordered_map>
#include <unordered_set>
#include <deque>
 
using namespace std;
 
typedef unsigned int uint;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair <int, int> par;
typedef pair <ll, ll> parll;
int const INF = 1e9 + 7;
ll const LLINF = 1e18 + 7;
ld const eps = 1e-10;
ld const PI = acos(-1);
ll const PH = 257;
ll const mod = 1e9 + 9;
 
par operator + (par const& a, par const& b) {
    return{ a.first + b.first, a.second + b.second };
}
int operator - (par const& a, par const& b) {
    return abs(a.first - b.first) + abs(a.second - b.second);
}
bool operator == (par const& a, par const& b) {
    return (a.first == b.first && a.second == b.second);
}
bool operator != (par const& a, par const& b) {
    return (a.first != b.first || a.second != b.second);
}
bool operator < (par const& a, par const& b) {
    return (a.first < b.first || (a.first == b.first && a.second < b.second));
}
istream& operator >> (istream& in, par & a) {
    return (in >> a.first >> a.second);
}
ostream& operator << (ostream& ou, par a) {
    return (ou << a.first << ' ' << a.second << '\n');
}
istream& operator >> (istream& in, parll & a) {
    return (in >> a.first >> a.second);
}
ostream& operator << (ostream& ou, parll a) {
    return (ou << a.first << ' ' << a.second << '\n');
}
 
 
namespace std {
    template <>
    struct hash<par> {
        std::size_t operator ()(par const& a) const {
            using std::hash;
            using std::size_t;
            return size_t((1LL * hash<int>()(a.first) * PH + hash<int>()(a.second)) % mod);
        }
    };
}
 
inline ll randll() {
    ll res = rand();
    for (int i = 0; i < 3; i++) {
        res <<= 16;
        res += rand();
    }
    return res;
}
 
inline ld log(ld a, ld b) {
    return (log(b) / log(a));
}
 
ll d[1510][1510];
ll dp[1510][1510];
ll up[1510][1510];
int n, m;
ll nwx[1510];
ll nwy[1510];
 
ll solve(par cur) {
    int x = cur.first, y = cur.second;
    
    for (int i = 0; i <= n; i++) nwy[i] = -ll(1e18);
    for (int j = 0; j <= m; j++) nwx[j] = -ll(1e18);
    if (y < m && x > 1) {
        nwx[y + 1] = dp[x - 1][y + 1] + d[x][y + 1];
        for (int j = y + 2; j <= m; j++) nwx[j] = max(nwx[j - 1], dp[x - 1][j]) + d[x][j];
    }
    if (x < n && y > 1) {
        nwy[x + 1] = dp[x + 1][y - 1] + d[x + 1][y];
        for (int i = x + 2; i <= n; i++) nwy[i] = max(nwy[i - 1], dp[i][y - 1]) + d[i][y];
    }
    
    ll ans = -LLINF;
    if (y < m) for (int j = y + 1; j <= m; j++) {
        ll dop = (x == n) ? 0 : up[x + 1][j];
        ans = max(ans, nwx[j] + dop);
    }
    if (x < n) for (int i = x + 1; i <= n; i++) {
        ll dop = (y == m) ? 0 : up[i][y + 1];
        if (nwy[i] > 0) ans = max(ans, nwy[i] + dop);
    }
    return ans;
}
 
int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w",stdout);
    ios::sync_with_stdio(false);
    cin >> n >> m;
    for (int i = 1; i <= n; i++) for (int j = 1; j <= m; j++) cin >> d[i][j];
    for (int i = 1; i <= n; i++) for (int j = 1; j <= m; j++) {
        dp[i][j] = max(dp[i - 1][j], dp[i][j - 1]) + d[i][j];
    }
    for (int i = n; i >= 1; i--) for (int j = m; j >= 1; j--) {
        up[i][j] += max(up[i + 1][j], up[i][j + 1]) + d[i][j];
    }
    vector <par> path;
    for (int x = n, y = m; !(x == 1 && y == 1);) {
        path.push_back({x, y});
        if (x > 1 && dp[x][y] == dp[x - 1][y] + d[x][y]) {
            x--;
        } else {
            y--;
        }
    }
    ll ans = LLINF;
    reverse(path.begin(), path.end());
    path.pop_back();
    for (par cur : path) ans = min(ans, solve(cur));
    assert(ans != LLINF && ans != -LLINF);
    cout << ans;
    return 0;
}