import java.util.*;
import java.io.*;

public class tablegame_gs {
    FastScanner in;
    PrintWriter out;

    final long INF = Long.MAX_VALUE / 4;

    public boolean isCorrect(int x, int y, int n, int m) {
        return x >= 0 && y >= 0 && x < n && y < m;
    }

    public void solve() throws IOException {
        int n = in.nextInt();
        int m = in.nextInt();
        int[][] a = new int[n][m];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                a[i][j] = in.nextInt();
            }
        }
        long[][] d = new long[n][m];
        for (int i = 0; i < n; i++) {
            Arrays.fill(d[i], 0);
        }
        d[0][0] = a[0][0];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (isCorrect(i - 1, j, n, m)) {
                    d[i][j] = Math.max(d[i][j], d[i - 1][j] + a[i][j]);
                }
                if (isCorrect(i, j - 1, n, m)) {
                    d[i][j] = Math.max(d[i][j], d[i][j - 1] + a[i][j]);
                }
            }
        }
        long[][] rd = new long[n][m];
        rd[n - 1][m - 1] = a[n - 1][m - 1];
        for (int i = n - 1; i >= 0; i--) {
            for (int j = m - 1; j >= 0; j--) {
                if (isCorrect(i + 1, j, n, m)) {
                    rd[i][j] = Math.max(rd[i][j], rd[i + 1][j] + a[i][j]);
                }
                if (isCorrect(i, j + 1, n, m)) {
                    rd[i][j] = Math.max(rd[i][j], rd[i][j + 1] + a[i][j]);
                }
            }
        }

        List[] win = new ArrayList[n + m + 1];
        for (int i = 0; i < n + m - 1; i++) {
            win[i] = new ArrayList();
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                long cur = d[i][j] + rd[i][j] - a[i][j];
                if (win[i + j].size() < 2) {
                    win[i + j].add(cur);
                } else if (cur > (Long)Collections.min(win[i + j])) {
                    ArrayList<Long> tmp = new ArrayList<>();
                    tmp.add(cur);
                    tmp.add((Long)Collections.max(win[i + j]));
                    win[i + j] = tmp;
                }
            }
        }
        long ans = INF;
        for (int i = 1; i < n + m - 2; i++) {
            ans = Math.min(ans, (Long)Collections.min(win[i]));
        }
        System.out.println(ans);
    }

    public void run() {
        try {
            in = new FastScanner();
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner() {
            br = new BufferedReader(new InputStreamReader(System.in));
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }

    public static void main(String[] arg) {
        new tablegame_gs().run();
    }
}